#ifndef BAR_H
#define BAR_H

#include <iostream>
using namespace std;

//! \brief Bar Class
/*!
* This is the Bar class which contains the Bar object constructor which creates
* one instance of a bar characteristized by its unqiue maxcapacity "maxcapacity"
* to be available to the simulated population to choice as well as two 
* additional functions:
*		getBarCapacity()
*		wonThisTurn(int peeps)
* which are used within the Town class. Detailed descriptions of the functions
* given below.
************************************************************************************************/
class Bar {
	public:
	
		//! \brief Default Bar Constructor.
		/*!
		* Default constructor NOT utilized within code.
		******************************************************************************************/
		Bar();
		
		//! \brief Bar Constructor
		/*!
		* \details Description: Bar Constructor which initializes a bars only attribute, its capacity to the 
		* sepecifed value. This is extracted from the what the user inputs into the GUI.
		* \param cap The value to which the Bars Object attribute "Maxcapacity" is defined as.
		* \pre A Town has been initialized.
		* \post The variable "Maxcapacity" is defined for a given bar.
		******************************************************************************************/
		Bar(int cap);
		
		//! \brief returns a bars "Maxcapacity"
		/*!
		* \details Description: Returns an integer which represents a bars "Maxcapacity".
		* \pre Attribute "Maxcapacity" is defined.
		* \post None.
		******************************************************************************************/
		int getBarCapacity();
		
		//! \brief Bar Class
		/*!
		* \details Description: Using division, we divide the number of people going to this bar by 
		* the bars attribute "Maxcapacity" in order return a number that shows what the bars capacity ratio
		* is for a specific round.
		* \param peeps The number of Agents who have decided to visit the given Bar Object.
		*\pre The number of Agents going to this specific bar has been decided.
		*\post The outcome of this bar(bar has won/lost) has been decided.
		*********************************************************************/
		double wonThisTurn(int peeps);

	private:
	
		/*! \brief A bars Maximum Capacity
		*
		* Contains the maximum capacity of a Bar 
		*/
		int maxcapacity;
};

#endif